#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct wc {
	char *word;
	int count;
};

static struct wc cwords[] = {
	{ "auto", 0 },
	{ "break", 0 },
	{ "case", 0 },
	{ "char", 0 },
	{ "const", 0 },
	{ "continue", 0 },
	{ "default", 0 },
	{ "do", 0 },
	{ "double", 0 },
	{ "else", 0 },
	{ "enum", 0 },
	{ "extern", 0 },
	{ "float", 0 },
	{ "for", 0 },
	{ "goto", 0 },
	{ "if", 0 },
	{ "int", 0 },
	{ "long", 0 },
	{ "register", 0 },
	{ "return", 0 },
	{ "short", 0 },
	{ "signed", 0 },
	{ "sizeof", 0 },
	{ "static", 0 },
	{ "struct", 0 },
	{ "switch", 0 },
	{ "typedef", 0 },
	{ "union", 0 },
	{ "unsigned", 0 },
	{ "void", 0 },
	{ "volatile", 0 },
	{ "while", 0 } 
};

static int nelem = 32;

void print()
{
	int i;

	for ( i = 0; i < nelem; i++ )
		printf( "%d\t%s\n", cwords[ i ].count, cwords[ i ].word );
}

static int bsearch_cmp( const void *key, const void *memb )
{
	char *w = (char *)key;
	struct wc *s = (struct wc *)memb;
	
	return strcmp( w, s->word );
}

void increment( char *word )
{
	struct wc *p = (struct wc *)bsearch( word, cwords, nelem, sizeof cwords[ 0 ], bsearch_cmp );

	if ( p != NULL ) p->count++;
}

static int qsort_cmp( const void *x, const void *y )
{
	struct wc *s = (struct wc *)x;
	struct wc *t = (struct wc *)y;
	
	if ( s->count > t->count ) return -1;
	else if ( s->count == t->count ) return 0;
	else return 1;
}

void sort( void )
{
	 qsort( cwords, nelem, sizeof cwords[ 0 ], qsort_cmp );
}
