#include <stdio.h>
#include <math.h>

#include "diag.h"

void swap( float *a, float *b ) 
{ 
	float t;

	t= *a; 
	*a = *b; 
	*b = t; 
}			

void eliminate( float ab[ MAX_N ][ MAX_N + 1 ], int n )
{
	int i, j, k, max;

	for ( i = 0; i < n; i++ ) {
		max = i;
		for ( j = i + 1; j < n; j++ )
			if ( fabs( ab[ j ][ i ] ) > fabs( ab[ max ][ i ] ) ) max = j;
		for ( k = i; k < n + 1; k++ )
			swap( &( ab[ i ][ k ] ), &( ab[ max ][ k ] ) );
		for ( j = i + 1; j < n; j++ )
			for ( k = n; k >= i; k-- )
				ab[ j ][ k ] -= ab[ i ][ k ] * ab[ j ][ i ] / ab[ i ][ i ];
	}
}

void substitute( float ab[ MAX_N ][ MAX_N + 1 ], float x[ MAX_N ], int n )
{
	int j, k;
	float t;
	
	for ( j = n - 1; j >= 0; j-- ) {
		t = 0.0;
		for ( k = j + 1; k < n; k++ )
			t += ab[ j ][ k ] * x[ k ];
		x[ j ] = ( ab[ j ][ n ] - t ) / ab[ j ][ j ];
	}
}
