#include <stdio.h>
#include <stdlib.h>
#include "diag.h"
#include "io.h"

int readab( const char *path, float ab[ MAX_N ][ MAX_N + 1 ] )
{
	FILE *infile;
	int n, i, j;

	if ( ( infile = fopen( path, "r" ) ) == NULL ) {
		perror( "readab" );
		exit( EXIT_FAILURE );
	}

	fscanf( infile, "%d", &n );

	if ( n > MAX_N ) {
		fprintf( stderr, "n should be less than or equal to %d\n", MAX_N );
		exit( EXIT_FAILURE );
	}

	for ( i = 0; i < n; i++ ) 
		for ( j = 0; j < n + 1; j++ ) 
			fscanf( infile, "%f", &( ab[ i ][ j ] ) );
	
	fclose( infile );
	
	return n;
}

void writex( float x[ MAX_N ], int n )
{
	int i;

	for ( i = 0; i < n; i++ )
		printf( "%+.2f\t", x[ i ] );
	putchar( '\n' );
}
